/***********************************************************************
 *                libdba - A database agent library                    *
 *             Copyright (C) 2000,2001 Michael Brownlow                *
 *                                                                     *
 * This program is free software; you can redistribute it and/or modify*
 * it under the terms of the GNU General Public License as published by*
 * the Free Software Foundation; either version 2 of the License, or   *
 * (at your option) any later version.                                 *
 *                                                                     *
 * This program is distributed in the hope that it will be useful,     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of      *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
 * GNU General Public License for more details.                        *
 *                                                                     *
 * You should have received a copy of the GNU General Public License   *
 * along with this program; if not, write to the Free Software         *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.           *
 *                                                                     *
 * For questions and comments, please email the author at:             *
 * mike@wsmake.org                                                     *
 ***********************************************************************/
#ifndef __DBA_CSV_H__
#define __DBA_CSV_H__ 1

#include "dba.h"

#undef __BEGIN_DECLS
#undef __END_DECLS
#ifdef __cplusplus
# define __BEGIN_DECLS extern "C" {
# define __END_DECLS }
#else
# define __BEGIN_DECLS /* empty */
# define __END_DECLS /* empty */
#endif

#undef __P
#if defined (__STDC__) || defined (_AIX) \
        || (defined (__mips) && defined (_SYSTYPE_SVR4)) \
                || defined(WIN32) || defined(__cplusplus)
# define __P(protos) protos
#else
# define __P(protos) ()
#endif

__BEGIN_DECLS

#ifdef HAVE_TARGET_CSV

#define DBA_CSV_MAX_KEYSIZE 1024

/* DB funcitons */
int __dba_csv_init __P((void));
int __dba_csv_open __P((DBA *));
int __dba_csv_load_db __P((DBA *));
int __dba_csv_sync_db __P((DBA *));
int __dba_csv_close __P((DBA *));
int __dba_csv_add __P((DBA *, int, const char *, ...));
int __dba_csv_set __P((DBA *, int, const char *, ...));
int __dba_csv_del __P((DBA *, const char *));
void *__dba_csv_get __P((DBA *, int, const char *, void *));
int __dba_csv_exists __P((DBA *, const char *));
int __dba_csv_register __P((DBA *));

#endif

__END_DECLS

#endif /* __DBA_DB_H__ */
