/***********************************************************************
 *                    libosa - OS and Stream Agent                     *
 *              Copyright (C) 2001,2002 Michael Brownlow               *
 *                                                                     *
 * This program is free software; you can redistribute it and/or modify*
 * it under the terms of the GNU General Public License as published by*
 * the Free Software Foundation; either version 2 of the License, or   *
 * (at your option) any later version.                                 *
 *                                                                     *
 * This program is distributed in the hope that it will be useful,     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of      *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
 * GNU General Public License for more details.                        *
 *                                                                     *
 * You should have received a copy of the GNU General Public License   *
 * along with this program; if not, write to the Free Software         *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.           *
 *                                                                     *
 * For questions and comments, please email the author at:             *
 * mike@wsmake.org                                                     *
 ***********************************************************************/
#include "osa.h"

#include <stdlib.h>

void *osaMalloc(size_t sz)
{
  register void *value = malloc(sz);
  if(value == 0) {
    osaPrintError(1, "Virtual memory exhausted");
  }
  return value;
}

void *osaRealloc(void *mem, size_t sz)
{
  register void *value = realloc(mem, sz);
  if(value == 0) {
    osaPrintError(1, "Virtual memory exhausted");
  }
  return value;
}

void *osaFree(void *mem)
{
  if(mem != NULL) {
    free(mem);
    mem = NULL;
  } else {
    osaPrintError(1, "Attempt to free NULL pointer");
  }
  return mem;
}
