/***********************************************************************
 *                    libosa - OS and Stream Agent                     *
 *              Copyright (C) 2001,2002 Michael Brownlow               *
 *                                                                     *
 * This program is free software; you can redistribute it and/or modify*
 * it under the terms of the GNU General Public License as published by*
 * the Free Software Foundation; either version 2 of the License, or   *
 * (at your option) any later version.                                 *
 *                                                                     *
 * This program is distributed in the hope that it will be useful,     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of      *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
 * GNU General Public License for more details.                        *
 *                                                                     *
 * You should have received a copy of the GNU General Public License   *
 * along with this program; if not, write to the Free Software         *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.           *
 *                                                                     *
 * For questions and comments, please email the author at:             *
 * mike@wsmake.org                                                     *
 ***********************************************************************/
#include "osa.h"

#include <errno.h>
#include <string.h>

char osaPrintLevel = 127;

void osaSetPrintLevel(char level)
{
  osaPrintLevel = level;
}

void osaPrintf(char level, const char *str, ...)
{
  va_list ap;

  if(osaPrintLevel >= level) {
    if(str != NULL) {
      va_start(ap, str);
      vfprintf(stdout, str, ap);
      va_end(ap);
    }
  }
}
