/***********************************************************************
 *         libwsmake - Core functionality library of wsmake            *
 *        Copyright (C) 1999,2000,2001,2002 Michael Brownlow           *
 *                                                                     *
 * This program is free software; you can redistribute it and/or modify*
 * it under the terms of the GNU General Public License as published by*
 * the Free Software Foundation; either version 2 of the License, or   *
 * (at your option) any later version.                                 *
 *                                                                     *
 * This program is distributed in the hope that it will be useful,     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of      *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
 * GNU General Public License for more details.                        *
 *                                                                     *
 * You should have received a copy of the GNU General Public License   *
 * along with this program; if not, write to the Free Software         *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.           *
 *                                                                     *
 * For questions and comments, please email the author at:             *
 * mike@wsmake.org                                                     *
 ***********************************************************************/
#include "wsSite.h"

#include "wsLoader.h"

using namespace wsmake;

list<wsSite *> wsmake::wsSite_list;

wsSite::wsSite(ast *a)
  : root(a)
{

}

wsSite::~wsSite()
{
  ast_free(root);
}

void wsSite::dumpSites()
{
  list<wsSite *>::const_iterator i;

  for(i=wsSite_list.begin(); i!=wsSite_list.end(); i++) {
    (*i)->dump();
  }
}

void wsSite::dump()
{
  ast_dump(root);
}

void wsSite::typeCheck()
{
  list<wsSite *>::const_iterator i;

  for(i=wsSite_list.begin(); i!=wsSite_list.end(); i++) {
    (*i)->tyCheck(NULL, 0);
  }
}

ast *wsSite::tyCheck(ast *ast, long level)
{
  return NULL;
}
