/* -*- C++ -*-
 ***********************************************************************
 *         libwsmake - Core functionality library of wsmake            *
 *        Copyright (C) 1999,2000,2001,2002 Michael Brownlow           *
 *                                                                     *
 * This program is free software; you can redistribute it and/or modify*
 * it under the terms of the GNU General Public License as published by*
 * the Free Software Foundation; either version 2 of the License, or   *
 * (at your option) any later version.                                 *
 *                                                                     *
 * This program is distributed in the hope that it will be useful,     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of      *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
 * GNU General Public License for more details.                        *
 *                                                                     *
 * You should have received a copy of the GNU General Public License   *
 * along with this program; if not, write to the Free Software         *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.           *
 *                                                                     *
 * For questions and comments, please email the author at:             *
 * mike@wsmake.org                                                     *
 ***********************************************************************/
#if !defined(__WSSITE_H__)
#define __WSSITE_H__ 1

#include <list>

#include "wsLoader.h"

namespace wsmake
{
  class wsSite {
  public:
    wsSite(ast *a);
    ~wsSite();

    static void dumpSites(void);
    static void typeCheck(void);
    void dump(void);

  protected:
    ast *tyCheck(ast *ast, long level);

  private:
    ast *root;
  };

  extern list<wsSite *> wsSite_list;
}
#else
namespace wsmake
{
  class wsSite;
}
#endif /* __WSSITE_H__ */
